=== debian/changelog ===
modules (5.5.0-1) unstable; urgency=medium

  * Fix broken vcs url
  * Standards-Version: 4.7.0; no changes required
  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 14 Nov 2024 17:27:01 +0000
