## modules 5.6.0

=== Makefile ===
--- 
+++ 
@@ -17,9 +17,9 @@
 
 # definitions for code coverage
 NAGELFAR_DLSRC1 := http://downloads.sourceforge.net/nagelfar/
-NAGELFAR_RELEASE := nagelfar133
+NAGELFAR_RELEASE := nagelfar135
 NAGELFAR_DIST := $(NAGELFAR_RELEASE).tar.gz
-NAGELFAR_DISTSUM := ab3451c8ba6b1ec9d9e26dec7e17b954
+NAGELFAR_DISTSUM := 0305ae1617a365626f45fc08909c6f58
 NAGELFAR := $(NAGELFAR_RELEASE)/nagelfar.tcl
 
 # definition for old Tcl interpreter for coverage testing
@@ -38,6 +38,12 @@
 
 # specific modulecmd script for test
 MODULECMDTEST := modulecmd-test.tcl
+# if coverage enabled, run tests on instrumented file to create coverage log
+ifeq ($(COVERAGE),y)
+MODULECMD := $(MODULECMDTEST)_i
+else
+MODULECMD := $(MODULECMDTEST)
+endif
 
 # definitions for enhanced diff tool (to review test results)
 ICDIFF_DLSRC := https://raw.githubusercontent.com/jeffkaufman/icdiff/release-2.0.4/
@@ -51,10 +57,9 @@
 
 INSTALL_PREREQ := modulecmd.tcl ChangeLog.gz README script/add.modules \
 	script/modulecmd
+TEST_PREREQ := $(MODULECMD)
 ifeq ($(COVERAGE),y)
-TEST_PREREQ := $(MODULECMDTEST)_i $(NAGELFAR)
-else
-TEST_PREREQ := $(MODULECMDTEST)
+TEST_PREREQ += $(NAGELFAR)
 endif
 
 ifeq ($(libtclenvmodules),y)
@@ -194,7 +199,7 @@
 # determine RPM release
 # use last release if we currently sat on tag, append build number to it elsewhere
 MODULES_LAST_RPM_VERSREL := $(shell sed -n '/^%changelog/ {n;s/^\*.* - //p;q;}' \
-	contrib/rpm/environment-modules.spec.in)
+	share/rpm/environment-modules.spec.in)
 MODULES_LAST_RPM_RELEASE := $(lastword $(subst -, ,$(MODULES_LAST_RPM_VERSREL)))
 MODULES_RPM_RELEASE := $(MODULES_LAST_RPM_RELEASE)$(subst +,.,$(subst -,.,$(MODULES_BUILD)))
 
@@ -311,6 +316,12 @@
   setconflictunload := 0
 endif
 
+ifeq ($(requirevia),y)
+  setrequirevia := 1
+else
+  setrequirevia := 0
+endif
+
 ifeq ($(implicitrequirement),y)
   setimplicitrequirement := 1
 else
@@ -321,6 +332,12 @@
   setavailindepth := 1
 else
   setavailindepth := 0
+endif
+
+ifeq ($(spiderindepth),y)
+  setspiderindepth := 1
+else
+  setspiderindepth := 0
 endif
 
 ifeq ($(implicitdefault),y)
@@ -430,10 +447,3 @@
 	-e 's|@tagabbrev@|$(tagabbrev)|g' \
 	-e 's|@tagcolorname@|$(tagcolorname)|g' \
 	-e 's|@stickypurge@|$(stickypurge)|g' \
-	-e 's|@abortonerror@|$(abortonerror)|g' \
-	-e 's|@availoutput@|$(availoutput)|g' \
-	-e 's|@availterseoutput@|$(availterseoutput)|g' \
-	-e 's|@listoutput@|$(listoutput)|g' \
-	-e 's|@listterseoutput@|$(listterseoutput)|g' \
-	-e 's|@variantshortcut@|$(variantshortcut)|g' \
-	-e 's|@editor@|$(editor)|g' \
