=== debian/changelog ===
modules (5.6.0-1) unstable; urgency=medium

   * New upstream release
   * Standards-Version: 4.7.2

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 18 Aug 2025 12:38:47 +0100
