## modules 5.6.1

=== Makefile ===
--- 
+++ 
@@ -13,7 +13,8 @@
 INSTALL_PROGRAM = $(INSTALL) -m 755
 
 # download command and its options
-WGET := wget --retry-connrefused --waitretry=20 --timeout=20 --tries=3
+CURL := curl --location --remote-name --retry 3 --retry-connrefused \
+	--retry-delay 20 --max-time 20
 
 # definitions for code coverage
 NAGELFAR_DLSRC1 := http://downloads.sourceforge.net/nagelfar/
@@ -446,4 +447,3 @@
 	-e 's|@nearlyforbiddendays@|$(nearlyforbiddendays)|g' \
 	-e 's|@tagabbrev@|$(tagabbrev)|g' \
 	-e 's|@tagcolorname@|$(tagcolorname)|g' \
-	-e 's|@stickypurge@|$(stickypurge)|g' \
