=== debian/changelog ===
modules (5.6.1-1) unstable; urgency=medium

  * New upstream release
  * d/rules: Clean config files for repeated builds. Closes: #1048655

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 30 Nov 2025 09:49:19 +0000
