=== debian/rules ===
--- 
+++ 
@@ -18,6 +18,7 @@
 override_dh_auto_clean:
 	$(MAKE) clean || echo "Make clean skipped"
 	rm -f stamp-h
+	rm -f Makefile.inc lib/Makefile lib/config.log lib/config.h lib/config.status site.exp
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
@@ -50,3 +51,5 @@
 	dh_link $(LIBDIR)/modulecmd.tcl /usr/lib/modulecmd.tcl
 	dh_link /usr/share/modules/init/csh		/etc/csh/login.d/modules
 	dh_link /usr/share/modules/init/bash_completion /usr/share/bash-completion/completions/modules
+	dh_link /usr/share/modules/init/fish /usr/share/fish/vendor_conf.d/modules.fish
+	dh_link /usr/share/modules/init/fish_completion /usr/share/fish/vendor_completions.d/modules.fish
